#ifndef BLOOMSET_H
#define BLOOMSET_H

#include "bloom.h"
#include <vector>

class bloomset_element {
    nsrl_bloom *bloom;
public:
    enum Action {INCLUDE,EXCLUDE} action;
    bloomset_element(Action action,const char *fname);
    int query(const unsigned char *hash) { return nsrl_bloom_query(bloom,hash); }
};

class bloomset : public std::vector<bloomset_element *> {
public:
    bool check_exclude(const unsigned char *hash); // returns true if this should be excluded
    // object is excluded if it is in an exclude bloom filter.
    // object is included if it is in an include bloom filter
    // if object is not present, if there are include filters it is excluded, otherwise it is included
};

#endif
