/*
 * tagset.h:
 * Keep track of the XML tags with a unordered_set.
 *
 * hash function is pretty simplistic.
 */

#ifndef TAGSET_H
#define TAGSET_H

#define USE_HASH_SET

#include <iostream>

#ifdef USE_HASH_SET
#include <set>
#include <ext/functional>
#include <ext/hash_set>

using namespace std;
using namespace __gnu_cxx;

namespace __gnu_cxx{
    template<>
    struct hash< string > {
	hash<unsigned> hasher;
	size_t operator()( const string &n)  const {
	    switch(n.size()){
	    case 0: return 0;
	    case 1: return (n[0]<<8) | n[1];
	    case 2: return (n[0]<<16) | (n[1]<<8) | (n[2]);
	    case 3:
	    default: return (n[0]<<24) | (n[1]<<16) | (n[2]<<8) | (n[3]);
	    }
	}
    };
}
struct eqstring{
    bool operator()( const string &s1,  const string  &s2) const {
	return s1 == s2;
    }
};
typedef hash_set< string , hash< string >, eqstring> tagset_;
#else
#error replacement for hash_set not impelemnted yet
#endif

class tagset: public tagset_ {
public:
    bool contains(const std::string &s) const {
	return find(s)!=end();
    }
};


#endif
